/* main.c - Game Startup */
/*
 * "Assasin v0.11"
 * 5/March/2003
 *
 *   Anotherslave	<anotherslave@froggy.com.au>
 *			<anotherslave@hotmail.com>
 * This software is released under the terms of the GPL.
 *
 * Contact authors for permission if you want to use this
 * software, or work derived from it, under other terms.
 *
 */




#include <stdio.h>
#include <stdlib.h>
#include "game.h"


char *title_string = "Assasin - version 0.1 ";

char IsMessage(void) {
	char message_waiting = 0;
	/* Code to check for messages goes here */

	if (message_waiting) {
		return 1;
	} else {
		return 0;
	}
}

void *GetMessage(void) {
	void *message;
	/* Code to retrieve message from queue goes here */

	return message;
}

void ProcessMessage(void *message) {
	/* Process the message here */
}

int HandleMouseEvent(SDL_Event *event, SDL_Surface *wscreen, SDL_Surface *wtarget);
void drawtarget(SDL_Surface *xscreen, SDL_Surface *xtarget, SDL_MouseMotionEvent *motion);
void displaycood(SDL_MouseMotionEvent *wmotion);

int main(int argc, char **argv) {
	void *message;
	
	SDL_Surface	*screen;
	SDL_Surface	*target;
	SDL_Rect	dest;
	SDL_Event	event;
	int		run=1;
	/* Display game title message */
	fprintf(stderr, title_string);

	/* Startup code goes here */

	/* initialize SDL */
	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) !=0) {
		fprintf(stderr, "SDL error: %s\n", SDL_GetError());
		return 0;
	}
	atexit(SDL_Quit);

	/* end init SDL */

	/* open a window in X */
	
	screen = SDL_SetVideoMode(
			320, 200, 		/* width and height of window */
			8,			/* 8 bit color depth (256 colors) */
			SDL_HWSURFACE | SDL_DOUBLEBUF	/* video flags */
	);

	if (screen == NULL) {
		fprintf(stderr, "Video error: %s\n", SDL_GetError());
		exit(1);
	}

	SDL_WM_SetCaption(title_string, NULL);
	
	/* load the bitmap with the background and target */	
	target = SDL_LoadBMP("target.bmp");
	
	/* Create a transparent color for the target surface */
	SDL_SetColorKey(target, SDL_SRCCOLORKEY, 0);
	
	/* Check what the color key is? */
	printf("the colorkey is %ld\n",target->format->colorkey);
	
	/* Make Cursor disappear */
	 SDL_ShowCursor(0);
	
	 /*end open window in X */			

	/* Enter main game loop */
	dest.x=0, dest.y=0, dest.w=320, dest.h=200;
	SDL_BlitSurface(target, NULL, screen, &dest);
	
	while(run) {
		if (SDL_PollEvent(&event)) {	
		switch(event.type){
			case SDL_MOUSEMOTION:
			case SDL_MOUSEBUTTONDOWN:
				run=HandleMouseEvent(&event, screen, target);
				break;
		}
		}
	
	}

	/* Shutdown code goes here */

	return 1;
}

int HandleMouseEvent(SDL_Event *event, SDL_Surface *wscreen, SDL_Surface *wtarget){
	/* Useful pointers to the required event structures */
	SDL_MouseMotionEvent *motion;
	SDL_MouseButtonEvent *button;
	int run;
	/*Switch based on the event type */
	switch(event->type){
		case SDL_MOUSEMOTION:
			motion=&event->motion;
			displaycood(motion);
			drawtarget(wscreen, wtarget, motion);
			run=1;
			break;
/*		printf("Mouse moved to: (%d, %d)\n", motion->x, motion->y);
			break;*/
		case SDL_MOUSEBUTTONDOWN:
			button=&event->button;
			printf("Exited with mouse button %d pressed at (%d, %d)\n", button->button, button->x, button->y);
			run=0;	
			break;
	//	default:
	//		break;
	}
	return run;
}

void drawtarget(SDL_Surface *xscreen, SDL_Surface *xtarget, SDL_MouseMotionEvent *xmotion){
	SDL_Rect dest, src, repair, repairsrc; 

		repair.x=(xmotion->x)-(xmotion->xrel);
		repair.y=(xmotion->y)-(xmotion->yrel);
		repair.w=18, repair.h=18;
		repairsrc.x=repair.x, repairsrc.y=repair.y, repairsrc.w=18, repairsrc.h=18;
		
		SDL_BlitSurface(xtarget, &repairsrc, xscreen, &repair);
	
	
	src.x=320, src.y=0, src.w=18, src.h=18;
	dest.x=xmotion->x, dest.y=xmotion->y, dest.w=20, dest.h=20; 
	SDL_BlitSurface(xtarget, &src, xscreen, &dest);
//	SDL_UpdateRects(xscreen, 1, &dest);
 	SDL_Flip(xscreen);	
	}

void displaycood(SDL_MouseMotionEvent *wmotion){

        	printf("Mouse moved to: (%d, %d)\n", wmotion->x, wmotion->y);
		printf("Relative motion: (%d, %d)\n", wmotion->xrel, wmotion->yrel);
}




	
